<?php
/*
 * www.Saba.Network
 */


if (!defined("ABSPATH")) {
    exit;
}
require_once "gateway_functions.php";
require_once "gateway_list.php";
add_action("admin_notices", "dig_accountkit_dep_notice");
function digit_getGatewayName($digit_tapp)
{
    switch ($digit_tapp) {
        case 2:
            return "Twilio";
            break;
        case 3:
            return "Msg91";
            break;
        case 4:
            return "Yunpian";
            break;
        default:
            return "";
    }
}
function dig_accountkit_dep_notice()
{
    echo "        \n        ";
}
function digit_apisettings()
{
    echo "\n\n    <h1>";
    _e("API Settings", "digits");
    echo "</h1>\n    <p class=\"lead\"></p>\n\n    <form method=\"post\">\n        ";
    digits_api_settings();
    echo "\n\n        <p class=\"digits-setup-action step\">\n            <Button type=\"submit\"\n                    class=\"button-primary button button-large button-next\">";
    _e("Continue", "digits");
    echo "</Button>\n            <a href=\"";
    echo admin_url("index.php?page=digits-setup&step=documentation");
    echo "\"\n               class=\"button\">";
    _e("Back", "digits");
    echo "</a>\n        </p>\n    </form>\n\n    ";
}
function digit_test_api_box()
{
    $countrycode = esc_attr(get_the_author_meta("digt_countrycode", get_current_user_id()));
    if (empty($countrycode)) {
        $countrycode = getUserCountryCode();
    }
    echo "    <div class=\"dig_api_test\">\n        <div class=\"dig_gateway_sep_line\"></div>\n\n        <div class=\"dig_call_test_api\">\n            <div>";
    _e("TEST GATEWAY SETTINGS", "digits");
    echo "</div>\n            <div class=\"dig_test_mob_ho\">\n\n                <div class=\"digcon\">\n                    <div class=\"dig_wc_countrycodecontainer dig_wc_logincountrycodecontainer\"\n                         style=\"display: inline-block;\">\n                        <input dig-save=\"0\" type=\"text\" name=\"digt_countrycode\"\n                               class=\"input-text countrycode dig_wc_logincountrycode\"\n                               value=\"";
    echo $countrycode;
    echo "\" maxlength=\"6\" size=\"3\"\n                               placeholder=\"";
    echo $countrycode;
    echo "\" autocomplete=\"none\">\n                    </div>\n                    <input dig-save=\"0\" class=\"mobile\" type=\"text\"\n                           placeholder=\"";
    _e("Your Mobile Number", "digits");
    echo "\"\n                           value=\"";
    echo esc_attr(get_the_author_meta("digits_phone_no", get_current_user_id()));
    echo "\"\n                           name=\"mobile/email\" style=\"padding-left:107px !important;\"></div>\n\n                <div class=\"dig_call_test_api_btn\">";
    _e("Test", "digits");
    echo "</div>\n            </div>\n\n        </div>\n\n        <div class=\"dig_call_test_response\">\n            <div class=\"dig_call_test_response_head\">";
    _e("Response", "digits");
    echo "</div>\n            <div class=\"dig_call_test_response_msg\"></div>\n        </div>\n    </div>\n    ";
}
function getWhatsAppGateWayArray()
{
    $gateways = [__("Disabled", "digits") => ["value" => -1, "inputs" => []], "Twilio" => ["value" => 2, "inputs" => [__("Twilio Account SID") => ["text" => true, "name" => "account_sid"], __("Twilio Auth Token") => ["text" => true, "name" => "auth_token"], __("Whatsapp Number") => ["text" => true, "name" => "whatsappnumber"]]], "MessageBird" => ["value" => 3, "require_addon" => 1, "inputs" => [__("Access Key") => ["text" => true, "name" => "accesskey"], __("Whatsapp Channel ID") => ["text" => true, "name" => "channel_id"]]], "Karix" => ["value" => 4, "require_addon" => 1, "inputs" => [__("UID") => ["text" => true, "name" => "uid"], __("Token") => ["text" => true, "name" => "token"], __("Sender") => ["text" => true, "name" => "sender"]]], "Gupshup" => ["value" => 5, "require_addon" => 1, "inputs" => [__("API Key") => ["text" => true, "name" => "api_key"], __("Source") => ["text" => true, "name" => "source"], __("WhatsApp app name") => ["text" => true, "name" => "src_name"]]]];
    return $gateways;
}
function getGateWayArray()
{
    $smsgateways = ["webone-sms.com" => ["value" => 332, "inputs" => [__("Username") => ["text" => true, "name" => "username"], __("Password") => ["text" => true, "name" => "password"], __("Sender") => ["text" => true, "name" => "sender"]]]];
    $smsgateways = apply_filters("unitedover_sms_gateways", $smsgateways);
    return $smsgateways;
}
function digits_api_settings()
{
    $digit_tapp = get_option("digit_tapp", 13);
    $app = get_option("digit_api");
    $appid = "";
    $appsecret = "";
    $accountkit_type = "";
    if ($app !== false) {
        $appid = $app["appid"];
        $appsecret = $app["appsecret"];
        if (isset($app["accountkit_type"])) {
            $accountkit_type = $app["accountkit_type"];
        } else {
            $accountkit_type = "modal";
        }
    }
    $tiwilioapicred = get_option("digit_twilio_api");
    $twiliosid = "";
    $twiliotoken = "";
    $twiliosenderid = "";
    if ($tiwilioapicred !== false) {
        $twiliosid = $tiwilioapicred["twiliosid"];
        $twiliotoken = $tiwilioapicred["twiliotoken"];
        $twiliosenderid = $tiwilioapicred["twiliosenderid"];
    }
    $msg91apicred = get_option("digit_msg91_api");
    $msg91authkey = "";
    $msg91senderid = "";
    $msg91route = 1;
    if ($msg91apicred !== false) {
        $msg91authkey = $msg91apicred["msg91authkey"];
        $msg91senderid = $msg91apicred["msg91senderid"];
        $msg91route = $msg91apicred["msg91route"];
        if (empty($msg91route)) {
            $msg91route = 2;
        }
    }
    $yunpianapi = get_option("digit_yunpianapi");
    digCountry();
    $smsgateways = getgatewayarray();
    echo "\n\n    <input type=\"hidden\" class=\"dig_save\" value='1' name=\"dig_save\"/>\n    <div class=\"digits_gateway_container digits_gateway_api_box\">\n        <table class=\"form-table digits_default_gateway_details gateway_table\">\n            ";
    digit_select_gateway("name=\"digit_tapp\" id=\"digit_tapp\"", $digit_tapp);
    echo "\n            <tr class=\"facebookcred gateway_conf\" ";
    if ($digit_tapp != 1) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"appid\">";
    _e("App ID", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"appid\" name=\"appid\" class=\"regular-text\" value=\"";
    echo $appid;
    echo "\"\n                           placeholder=\"";
    _e("App ID", "digits");
    echo "\"\n                           autocomplete=\"off\"/>\n                </td>\n            </tr>\n            <tr class=\"facebookcred gateway_conf\" ";
    if ($digit_tapp != 1) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"appsecret\">";
    _e("AccountKit App Secret", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"appsecret\" name=\"appsecret\" class=\"regular-text\"\n                           value=\"";
    echo $appsecret;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("App Secret", "digits");
    echo "\"/>\n                </td>\n            </tr>\n\n            <tr class=\"facebookcred gateway_conf\" ";
    if ($digit_tapp != 1) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"accountkit_type\">";
    _e("Type", "digits");
    echo " </label></th>\n                <td>\n                    <select name=\"accountkit_type\">\n                        <option value=\"modal\" ";
    if ($accountkit_type == "modal") {
        echo "selected='selected'";
    }
    echo ">";
    _e("Modal", "digits");
    echo "</option>\n                        <option value=\"popup\" ";
    if ($accountkit_type == "popup") {
        echo "selected='selected'";
    }
    echo ">";
    _e("Popup", "digits");
    echo "</option>\n                    </select>\n\n                    <p class=\"dig_ecr_desc\">\n                        ";
    _e("Only use Popup if your website is non https:// otherwise we highly recommend using modal.", "digits");
    echo "                    </p>\n                </td>\n            </tr>\n\n\n            <tr class=\"twiliocred gateway_conf\" ";
    if ($digit_tapp != 2) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"twiliosid\">";
    _e("Account SID", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"twiliosid\" name=\"twiliosid\" class=\"regular-text\"\n                           value=\"";
    echo $twiliosid;
    echo "\"\n                           placeholder=\"";
    _e("Account SID", "digits");
    echo "\"\n                           autocomplete=\"off\"/>\n                </td>\n            </tr>\n            <tr class=\"twiliocred gateway_conf\" ";
    if ($digit_tapp != 2) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"twiliotoken\">";
    _e("Auth Token", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"twiliotoken\" name=\"twiliotoken\" class=\"regular-text\"\n                           value=\"";
    echo $twiliotoken;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("Auth Token", "digits");
    echo "\"/>\n                </td>\n            </tr>\n            <tr class=\"twiliocred gateway_conf\" ";
    if ($digit_tapp != 2) {
        echo "style=\"display:none;\"";
    }
    echo " >\n                <th scope=\"row\"><label for=\"twiliosenderid\">";
    _e("Sender ID", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"twiliosenderid\" name=\"twiliosenderid\" class=\"regular-text\"\n                           value=\"";
    echo $twiliosenderid;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("Sender ID", "digits");
    echo "\"/>\n                </td>\n            </tr>\n\n            <tr class=\"msg91cred gateway_conf\" ";
    if ($digit_tapp != 3) {
        echo "style=\"display:none;\"";
    }
    echo ">\n                <th scope=\"row\"><label for=\"msg91authkey\">";
    _e("Authentication Key", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"msg91authkey\" name=\"msg91authkey\" class=\"regular-text\"\n                           value=\"";
    echo $msg91authkey;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("Authentication Key", "digits");
    echo "\"/>\n                </td>\n            </tr>\n            <tr class=\"msg91cred gateway_conf\" ";
    if ($digit_tapp != 3) {
        echo "style=\"display:none;\"";
    }
    echo ">\n                <th scope=\"row\"><label for=\"msg91route\">";
    _e("ROUTE", "digits");
    echo " </label></th>\n                <td>\n                    <select name=\"msg91route\">\n                        <option value=\"1\" ";
    if ($msg91route == 1) {
        echo "selected='selected'";
    }
    echo ">";
    _e("SendOTP", "digits");
    echo "</option>\n                        <option value=\"2\" ";
    if ($msg91route == 2) {
        echo "selected='selected'";
    }
    echo ">";
    _e("Transactional", "digits");
    echo "</option>\n                    </select>\n                    <p class=\"dig_ecr_desc\">\n                        If your website users are only from <b>India</b> then you can use <b>Transactional</b> or\n                        <b>SendOTP</b> route. But if your users are from any other <b>country than India</b> then you\n                        should\n                        only use <b>SendOTP</b> route.\n                    </p>\n                </td>\n            </tr>\n            <tr class=\"msg91cred gateway_conf\" ";
    if ($digit_tapp != 3) {
        echo "style=\"display:none;\"";
    }
    echo ">\n                <th scope=\"row\"><label for=\"msg91senderid\">";
    _e("Sender ID", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"msg91senderid\" name=\"msg91senderid\" class=\"regular-text\"\n                           value=\"";
    echo $msg91senderid;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("Sender ID", "digits");
    echo "\"\n                           maxlength=\"6\"/>\n                </td>\n            </tr>\n\n\n            <tr class=\"yunpiancred gateway_conf\" ";
    if ($digit_tapp != 4) {
        echo "style=\"display:none;\"";
    }
    echo ">\n                <th scope=\"row\"><label for=\"yunpianapikey\">";
    _e("API Key", "digits");
    echo " </label></th>\n                <td>\n                    <input type=\"text\" id=\"yunpianapikey\" name=\"yunpianapikey\" class=\"regular-text\"\n                           value=\"";
    echo $yunpianapi;
    echo "\" autocomplete=\"off\"\n                           placeholder=\"";
    _e("API Key", "digits");
    echo "\"/>\n                    <p class=\"dig_ecr_desc\">";
    _e("Please keep this message template similar to the one on Yunpian, just replace #code# with {OTP} otherwise messages will not be sent.", "digits");
    echo "</p>\n                </td>\n            </tr>\n\n            ";
    dig_show_gateway_api_fields($smsgateways, $digit_tapp, "");
    echo "\n\n        </table>\n\n\n        ";
    $dig_messagetemplate = get_option("dig_messagetemplate", "کاربر گرامی به {NAME} خوش آمدید کد تایید شما : {OTP}");
    echo "        <table class=\"form-table\">\n            <tr class=\"disotp\">\n                <th scope=\"row\" style=\"vertical-align:top;\"><label\n                            for=\"dig_messagetemplate\">";
    _e("Message Template", "digits");
    echo "</label></th>\n                <td>\n                    <input type=\"text\" style=\"direction: rtl;\" name=\"dig_messagetemplate\" value=\"";
    echo $dig_messagetemplate;
    echo "\"\n                           placeholder=\"Message Template\" class=\"dig_inp_wid3\"\n                           required>\n                    <p class=\"dig_ecr_desc\">\n                        ";
    _e("Site Name", "digits");
    echo " - {NAME}<Br/>";
    _e("OTP", "digits");
    echo " -\n                        {OTP}</p>\n\n                </td>\n            </tr>\n        </table>\n        ";
    digit_test_api_box();
    echo "    </div>\n    ";
    do_action("digits_api_settings");
}
function digit_select_gateway($gatewayAttributes, $digit_tapp = -1, $smsgateways = [], $isWhatsapp = false)
{
    if (empty($smsgateways)) {
        $loadDefault = true;
        $smsgateways = getgatewayarray();
    }
    if ($isWhatsapp) {
        $gatewayLabel = __("WhatsApp Gateway", "digits");
    } else {
        $gatewayLabel = __("SMS Gateway", "digits");
    }
    $gatewayName = digit_getgatewayname($digit_tapp);
    iniFireBaseinit();
    echo "\n    <tr>\n        <th scope=\"row\" valign=\"top\" style=\"vertical-align: top;\">\n            <label>";
    echo $gatewayLabel;
    echo " </label></th>\n        <td class=\"dig-gs-gatway-select-td\">\n\n            <select class=\"digit_gateway\" ";
    echo $gatewayAttributes;
    echo " autocomplete=\"off\">\n                ";
    $list = apply_filters("digits_addon", []);
    $additional_gateway_installed = !in_array("additional-gateways", $list) ? false : true;
    $gateway_groups = apply_filters("digits_group_gateways_list", $smsgateways);
    foreach ($gateway_groups as $group_name => $gateway_group) {
        $optgroup_label = "label=\"" . esc_attr__($group_name) . "\"";
        if ($group_name == "starting_group") {
            $optgroup_label = "";
        }
        if ($group_name != "hide") {
            echo "<optgroup " . $optgroup_label . ">";
        }
        foreach ($gateway_group as $name => $details) {
            $sel = "";
            $value = $details["value"];
            $data_test = isset($details["data-test"]) ? "data-test=\"0\"" : "";
            if ($value == $digit_tapp) {
                $gatewayName = $name;
                $sel = "selected=\"selected\"";
            }
            if ($isWhatsapp) {
                $prefix = "whatsapp";
            } else {
                $prefix = "";
            }
            $han = digits_strtolower(str_replace([".", " "], "_", $prefix . $name));
            $gateway_label = isset($details["label"]) ? $details["label"] : $name;
            $require_addon = isset($details["require_addon"]) && !$additional_gateway_installed ? $details["require_addon"] : 0;
            echo "<option data-addon=\"" . $require_addon . "\" data-value=\"" . $value . "\" value=\"" . $value . "\" " . $sel . " han=\"" . $han . "\" " . $data_test . ">" . $gateway_label . "</option>";
        }
        if ($group_name != "hide") {
            echo "</optgroup>";
        }
    }
    echo "            </select><br/>\n            <div>\n                ";
    if (!$isWhatsapp) {
        echo "                    <span class=\"dig_current_gateway\"\n                          style=\"";
        if ($digit_tapp == 1 || $digit_tapp == 13 || $digit_tapp == -1 || $digit_tapp == 900) {
            echo "display:none;";
        }
        echo "\">";
        printf(__("You should have paid <span>%s</span> plan to use this.", "digits"), $gatewayName);
        echo "</span>\n\n                    <p class=\"dig_accountkit_notice facebookcred gateway_conf\" ";
        if ($digit_tapp != 1) {
            echo "style=\"display:none;\"";
        }
        echo ">\n                        Account Kit by Facebook is depreciated as of September 9, 2019, you can read more about it <a\n                                target=\"_blank\"\n                                href=\"https://developers.facebook.com/blog/post/2019/09/09/account-kit-services-no-longer-available-starting-march\">here</a>.\n                        If you are already using it then you can use it until March 9, 2020 or else you can switch your\n                        gateway\n                        to Firebase (Free).<br/><br/>\n                        <b>Your user data will not get affected in any way as it gets stored on your website and all of\n                            your\n                            old/new users will be able to login or signup using any other gateway.</b>\n                    </p>\n                ";
    }
    echo "\n                ";
    if (!$additional_gateway_installed) {
        echo "                    <p class=\"dig_ecr_desc require_addon_text\">";
        esc_html_e("Please install Additional Gateways addon to use this as SMS gateway");
        echo "                    <a href=\"#\" class=\"digits_install_additional_gateways\">";
        esc_html_e("Click Here");
        echo "</a>\n                    </p>";
    }
    echo "            </div>\n\n        </td>\n    </tr>\n    ";
}
function dig_show_gateway_api_fields($smsgateways, $digit_tapp, $prefix = "")
{
    $list = apply_filters("digits_addon", []);
    $additional_gateway_installed = !in_array("additional-gateways", $list) ? false : true;
    foreach ($smsgateways as $name => $details) {
        $value = $details["value"];
        $name = str_replace([".", " "], "_", $prefix . digits_strtolower($name));
        $gatewayCreds = get_option("digit_" . digits_strtolower($name));
        foreach ($details["inputs"] as $inputLabel => $input) {
            $inputname = $name . "_" . $input["name"];
            if (isset($gatewayCreds[$input["name"]])) {
                $inputValue = stripslashes($gatewayCreds[$input["name"]]);
            } else {
                $inputValue = "";
            }
            $optional = 0;
            if (isset($input["optional"])) {
                $optional = $input["optional"];
            }
            $attrs = [];
            if (!$additional_gateway_installed && isset($details["require_addon"]) && $details["require_addon"] == 1) {
                $attrs[] = "disabled=\"disabled\"";
            }
            $attrs = implode(" ", $attrs);
            echo "            <tr class=\"";
            echo $name;
            echo "cred gateway_conf\" ";
            if ($digit_tapp != $value) {
                echo "style=\"display:none;\"";
            }
            echo ">\n                <th scope=\"row\"><label for=\"";
            echo $inputname;
            echo "\"> ";
            _e($inputLabel, "digits");
            if ($optional == 1) {
            }
            echo " </label></th>\n                <td>\n                    ";
            if (isset($input["textarea"])) {
                echo "                                <textarea type=\"text\" id=\"";
                echo $inputname;
                echo "\" name=\"";
                echo $inputname;
                echo "\"\n                                          class=\"regular-text\"\n                                          autocomplete=\"off\"\n                                          rows=\"3\"\n                                          placeholder=\"";
                _e($inputLabel, "digits");
                echo "\"\n                                          dig-optional=\"";
                echo $optional;
                echo "\">";
                echo $inputValue;
                echo "</textarea>\n\t\t\t\t\t\t\t\t";
            } else {
                if ($input["text"]) {
                    echo "                                <input type=\"text\" id=\"";
                    echo $inputname;
                    echo "\" name=\"";
                    echo $inputname;
                    echo "\"\n                                       class=\"regular-text\"\n                                       value=\"";
                    echo $inputValue;
                    echo "\" autocomplete=\"off\"\n                                       placeholder=\"";
                    _e($inputLabel, "digits");
                    echo "\"\n                                       dig-optional=\"";
                    echo $optional;
                    echo "\"/>\n\t\t\t\t\t\t\t\t";
                } else {
                    echo "\t\t\t\t\t\t\t\t<select name=\"";
                    echo $inputname;
                    echo "\" id=\"";
                    echo $inputname;
                    echo "\" class=\"regular-text\" dig-optional=\"";
                    echo $optional;
                    echo "\" onChange=\"\">\n\t\t\t\t\t\t\t\t\t<option value='0' ";
                    if ($inputValue == 0) {
                        echo "selected";
                    }
                    echo " >";
                    _e("No", "digits");
                    echo "</option>\n\t\t\t\t\t\t\t\t\t<option value='1' ";
                    if ($inputValue == 1) {
                        echo "selected";
                    }
                    echo " >";
                    _e("Yes", "digits");
                    echo "</option>\n\t\t\t\t\t\t\t\t</select>\n\t\t\t\t\t\t\t\t";
                }
            }
            echo "                </td>\n            </tr>\n            ";
        }
    }
}
function digits_update_api_settings()
{
    $smsgateways = getgatewayarray();
    digits_update_gateway_api_details($smsgateways, "");
    digits_update_gateway_api_details(getwhatsappgatewayarray(), "whatsapp");
    update_option("digit_whatsapp_gateway", sanitize_text_field($_POST["digit_whatsapp_gateway"]));
}
function digits_update_gateway_api_details($smsgateways, $prefix)
{
    foreach ($smsgateways as $name => $details) {
        $name = digits_strtolower(str_replace([".", " "], "_", $name));
        $gatewaycred = [];
        foreach ($details["inputs"] as $inputlabel => $input) {
            if (isset($input["textarea"])) {
                $inputValue = $_POST[$prefix . $name . "_" . $input["name"]];
            } else {
                $inputValue = $_POST[$prefix . $name . "_" . $input["name"]];
            }
            $gatewaycred[$input["name"]] = $inputValue;
        }
        update_option("digit_" . $prefix . digits_strtolower($name), $gatewaycred);
    }
}

?>