<?php
/*
 * www.Saba.Network
 */

/**
* Main webone.ir API Class
* 
* @package  webone.ir
*/
class digits_webone_ir
{
private $username = NULL;
private $Password = NULL;
private $sender = NULL;
public function __construct($arg, $options = [])
{
if (empty($arg)) {
digitsDebug("Username and Password and Sender can't be blank");
wp_die("Username and Password and Sender can't be blank");
} else {
$this->username = $arg["username"];
$this->password = $arg["password"];
$this->sender = $arg["sender"];
}
}
public function send($sms)
{
if (!is_array($sms)) {
digitsDebug("sms parameter must be an array");
return ["success" => false];
}
ini_set("soap.wsdl_cache_enabled", "0");
$sms_client = new SoapClient('http://payamakapi.ir/SendService.svc?wsdl', array('encoding'=>'UTF-8'));

try {
$parameters['userName'] = $this->username;
$parameters['password'] = $this->password;
$parameters['fromNumber'] = $this->sender;
$parameters['toNumbers'] = array( $sms["to"] );
$parameters['messageContent'] = $sms["message"];
$parameters['isFlash'] = false;
$recId = array(0);
$status = 0x0;
$parameters['recId'] = &$recId ;
$parameters['status'] = &$status ;
$statusend =  $sms_client->SendSMS($parameters)->SendSMSResult;
}  
catch (Exception $e) 
{
$errorwebone = getMessage();
}


finally {

if (1 == $statusend) {
$typeerror = "نام کاربری یا کلمه عبور درست نمی باشد : ";
print $typeerror;
return ["success" => false];
}
if (2 == $statusend) {
$typeerror = "کاربر مسدود شده است : ";
print $typeerror;
return ["success" => false];
}
if (3 == $statusend) {
$typeerror = "شماره فرستنده نامعتبر است : ";
print $typeerror;
return ["success" => false];
}
if (4 == $statusend) {
$typeerror = "محدودیت در ارسال روزانه : ";
print $typeerror;
return ["success" => false];
}
if (5 == $statusend) {
$typeerror = "تعداد گیرندگان حداکثر 100 شماره می باشد : ";
print $typeerror;
return ["success" => false];
}
if (6 == $statusend) {
$typeerror = "خط فرسنتده غیرفعال است : ";
print $typeerror;
return ["success" => false];
}
if (7 == $statusend) {
$typeerror = "متن پیامک شامل کلمات فیلتر شده است : ";
print $typeerror;
return ["success" => false];
}
if (8 == $statusend) {
$typeerror = "اعتبار کافی نیست : ";
print $typeerror;
return ["success" => false];
}
if (9 == $statusend) {
$typeerror = "سامانه در حال بروز رسانی می باشد : ";
print $typeerror;
return ["success" => false];
}
if (10 == $statusend) {
$typeerror = "وب سرویس غیرفعال است : ";

print $typeerror;
return ["success" => false];
}

}
return ["success" => true];
   
  
}
}

?>